**********************************************************************
DEFINE CLASS TestUndoEngine as FxuTestCase OF FxuTestCase.prg
**********************************************************************
#IF .f.
*
*  this LOCAL declaration enabled IntelliSense for
*  the THIS object anywhere in this class
*
LOCAL THIS AS TestUndoEngine OF TestUndoEngine.PRG
#ENDIF

*
*  declare properties here that are used by one or
*  more individual test methods of this class
*
*  for example, if you create an object to a custom
*  THIS.Property in THIS.Setup(), estabish the property
*  here, where it will be available (to IntelliSense)
*  throughout:
*
*!*		ioObjectToBeTested = .NULL.
*!*		icSetClassLib = SPACE(0)
oUndoEngine = .null.

* the icTestPrefix property in the base FxuTestCase class defaults
* to "TEST" (not case sensitive). There is a setting on the interface
* tab of the options form (accessible via right-clicking on the
* main FoxUnit form and choosing the options item) labeld as
* "Load and run only tests with the specified icTestPrefix value in test classes"
*
* If this is checked, then only tests in any test class that start with the
* prefix specified with the icTestPrefix property value will be loaded
* into FoxUnit and run. You can override this prefix on a per-class basis.
*
* This makes it possible to create ancillary methods in your test classes
* that can be shared amongst other test methods without being run as
* tests themselves. Additionally, this means you can quickly and easily
* disable a test by modifying it and changing it's test prefix from
* that specified by the icTestPrefix property

* Additionally, you could set this in the INIT() method of your derived class
* but make sure you dodefault() first. When the option to run only
* tests with the icTestPrefix specified is checked in the options form,
* the test classes are actually all instantiated individually to pull
* the icTestPrefix value.

*!*		icTestPrefix = "<Your preferred prefix here>"

********************************************************************
PROCEDURE Setup
********************************************************************
*
*  put common setup code here -- this method is called
*  whenever THIS.Run() (inherited method) to run each
*  of the custom test methods you add, specific test
*  methods that are not inherited from FoxUnit
*
*  do NOT call THIS.Assert..() methods here -- this is
*  NOT a test method
*
*  for example, you can instantiate all the object(s)
*  you will be testing by the custom test methods of
*  this class:
*!*		THIS.icSetClassLib = SET("CLASSLIB")
*!*		SET CLASSLIB TO MyApplicationClassLib.VCX ADDITIVE
*!*		THIS.ioObjectToBeTested = CREATEOBJECT("MyNewClassImWriting")

This.oUndoEngine = NEWOBJECT("UndoEngine", "UndoEngine.PRG")
********************************************************************
ENDPROC
********************************************************************

********************************************************************
PROCEDURE TearDown
********************************************************************
*
*  put common cleanup code here -- this method is called
*  whenever THIS.Run() (inherited method) to run each
*  of the custom test methods you add, specific test
*  methods that are not inherited from FoxUnit
*
*  do NOT call THIS.Assert..() methods here -- this is
*  NOT a test method
*
*  for example, you can release  all the object(s)
*  you will be testing by the custom test methods of
*  this class:
*!*	    THIS.ioObjectToBeTested = .NULL.
*!*		LOCAL lcSetClassLib
*!*		lcSetClassLib = THIS.icSetClassLib
*!*		SET CLASSLIB TO &lcSetClassLib
This.oUndoEngine = .null.
********************************************************************
ENDPROC
********************************************************************	

*
*  test methods can use any method name not already used by
*  the parent FXUTestCase class
*    MODIFY COMMAND FXUTestCase
*  DO NOT override any test methods except for the abstract
*  test methods Setup() and TearDown(), as described above
*
*  the three important inherited methods that you call
*  from your test methods are:
*    THIS.AssertTrue("Failure message",<Expression>)
*    THIS.AssertEquals("Failure message",<ExpectedValue>,<Expression>)
*    THIS.AssertNotNull("Failure message",<Expression>)
*  all test methods either pass or fail -- the assertions
*  either succeed or fail

*
*  here's a simple AssertNotNull example test method
*
*!*		*********************************************************************
*!*		PROCEDURE TestObjectWasCreated
*!*		*********************************************************************
*!*		THIS.AssertNotNull("Object was not instantiated during Setup()", ;
*!*			               THIS.ioObjectToBeTested)
*!*		*********************************************************************
*!*		ENDPROC
*!*		*********************************************************************

*
*  here's one for AssertTrue
*
*!*		*********************************************************************
*!*		PROCEDURE TestObjectCustomMethod
*!*		*********************************************************************
*!*		THIS.AssertTrue("Object.CustomMethod() failed", ;
*!*			            THIS.ioObjectToBeTested.CustomMethod())
*!*		*********************************************************************
*!*		ENDPROC
*!*		*********************************************************************

*
*  and one for AssertEquals
*
*!*		*********************************************************************
*!*		PROCEDURE TestObjectCustomMethod100ReturnValue
*!*		*********************************************************************
*!*
*!*		* Please note that string Comparisons with AssertEquals are
*!*		* case sensitive.
*!*
*!*		THIS.AssertEquals("Object.CustomMethod100() did not return 'John Smith'", ;
*!*		                "John Smith", ;
*!*			            THIS.ioObjectToBeTested.Object.CustomMethod100())
*!*		*********************************************************************
*!*		ENDPROC
*!*		*********************************************************************

*********************************************************************
PROCEDURE TestObjectWasCreated
*********************************************************************
THIS.AssertNotNull("Object was not instantiated during Setup()", ;
	               THIS.oUndoEngine)
*********************************************************************
ENDPROC
*********************************************************************

*********************************************************************
PROCEDURE TestRegisterMethod
*********************************************************************

LOCAL oTestObj

* Create the object to be registered
oTestObj = CREATEOBJECT("form")
This.oUNDOENGINE.Register(oTestObj, "Show", "Test1", "SaveShow", "RestoreShow")
This.Assertequals("Registration failed", 1, This.oUNDOENGINE.oUndoList.Count)

*********************************************************************
ENDPROC
*********************************************************************

*********************************************************************
PROCEDURE TestTriggerUndoEvent
*********************************************************************

LOCAL oTestObj, nPriorCount, nOldSession

* Get undo table record count
nOldSession = SET("DataSession")
SET DATASESSION TO This.oUnDOENGINE.nDataSession
nPriorCount = RECCOUNT("__UndoTrail")
* Create the object to be registered
oTestObj = CREATEOBJECT("UndoTester")
This.oUNDOENGINE.Register(oTestObj, "Stuff", "Test1", "SaveStuff", "RestoreStuff")
oTestObj.Stuff()

This.Assertequals("Undo record not added to table", nPriorCount + 1, RECCOUNT("__UndoTrail"))
This.Assertequals("Data not properly saved", "Data to save", __UndoTrail.mData)

SET DATASESSION TO (nOldSession)
RETURN

*********************************************************************
ENDPROC
*********************************************************************

*********************************************************************
PROCEDURE TestUndo
*********************************************************************
LOCAL oTestObj, nOldSession, iTestID


* Create the object to be registered
oTestObj = CREATEOBJECT("UndoTester")
This.oUNDOENGINE.Register(oTestObj, "Stuff", "Test1", "SaveStuff", "RestoreStuff")
oTestObj.Stuff()

nOldSession = SET("DataSession")
SET DATASESSION TO This.oUnDOENGINE.nDataSession
iTestID = __UndoTrail.iID
SET DATASESSION TO (nOldSession)

* Fire the Undo
This.oUNDOENGINE.Undo("Test1")

* Check result
SET DATASESSION TO This.oUnDOENGINE.nDataSession

SEEK m.iTestID IN __UndoTrail ORDER iID
This.Asserttrue("Action not marked as undone", not EMPTY(__UndoTrail.tUndone))

SET DATASESSION TO (nOldSession)

RETURN

*********************************************************************
ENDPROC
*********************************************************************

*********************************************************************
PROCEDURE UndoWithoutDo
*********************************************************************
* Test what happens if there's nothing to undo

LOCAL lReturn

lReturn = This.oUNDOENGINE.Undo("UnknownType")

This.Assertequals("No undo available doesn't fail", .f., m.lReturn)

RETURN

*********************************************************************
ENDPROC
*********************************************************************



**********************************************
FUNCTION TestRegisterControlMethod
**********************************************

LOCAL oTestObj

* Create the object to be registered
oTestObj = CREATEOBJECT("form")
oTestObj.AddObject("txtTest", "textbox")
This.oUNDOENGINE.Register(oTestObj.txtTest, "Visible", "Test1", "SaveShow", "RestoreShow")
This.Assertequals("Registration failed", 1, This.oUNDOENGINE.oUndoList.Count)

**********************************************
ENDFUNC 
**********************************************

**********************************************************************
ENDDEFINE
**********************************************************************

DEFINE CLASS UndoTester AS Custom

PROCEDURE Stuff

ENDPROC

PROCEDURE SaveStuff

RETURN "Data to save"

ENDPROC

PROCEDURE RestoreStuff(cRestoreData)

RETURN .t.
ENDPROC

ENDDEFINE

