**********************************************************************
DEFINE CLASS TestUndoObject as FxuTestCase OF FxuTestCase.prg
**********************************************************************
#IF .f.
*
*  this LOCAL declaration enabled IntelliSense for
*  the THIS object anywhere in this class
*
LOCAL THIS AS TestUndoObject OF TestUndoObject.PRG
#ENDIF

*  
*  declare properties here that are used by one or
*  more individual test methods of this class
*
*  for example, if you create an object to a custom
*  THIS.Property in THIS.Setup(), estabish the property
*  here, where it will be available (to IntelliSense)
*  throughout:
*
*!*		ioObjectToBeTested = .NULL.
*!*		icSetClassLib = SPACE(0)

oUndoObject = .null.
oForm = .null.

* the icTestPrefix property in the base FxuTestCase class defaults
* to "TEST" (not case sensitive). There is a setting on the interface
* tab of the options form (accessible via right-clicking on the
* main FoxUnit form and choosing the options item) labeld as
* "Load and run only tests with the specified icTestPrefix value in test classes"
*
* If this is checked, then only tests in any test class that start with the
* prefix specified with the icTestPrefix property value will be loaded
* into FoxUnit and run. You can override this prefix on a per-class basis.
*
* This makes it possible to create ancillary methods in your test classes
* that can be shared amongst other test methods without being run as
* tests themselves. Additionally, this means you can quickly and easily 
* disable a test by modifying it and changing it's test prefix from
* that specified by the icTestPrefix property

* Additionally, you could set this in the INIT() method of your derived class
* but make sure you dodefault() first. When the option to run only
* tests with the icTestPrefix specified is checked in the options form,
* the test classes are actually all instantiated individually to pull
* the icTestPrefix value.

*!*		icTestPrefix = "<Your preferred prefix here>"

********************************************************************
FUNCTION Setup
********************************************************************
*
*  put common setup code here -- this method is called
*  whenever THIS.Run() (inherited method) to run each
*  of the custom test methods you add, specific test
*  methods that are not inherited from FoxUnit
*
*  do NOT call THIS.Assert..() methods here -- this is
*  NOT a test method
*
    *  for example, you can instantiate all the object(s)
    *  you will be testing by the custom test methods of 
    *  this class:
*!*		THIS.icSetClassLib = SET("CLASSLIB")
*!*		SET CLASSLIB TO MyApplicationClassLib.VCX ADDITIVE
*!*		THIS.ioObjectToBeTested = CREATEOBJECT("MyNewClassImWriting")

This.oForm = CREATEOBJECT("Form")
This.oForm.AddProperty("oUndoObject", NEWOBJECT("UndoObject", "UndoEngine.PRG","",This.oForm))

********************************************************************
ENDFUNC
********************************************************************

********************************************************************
FUNCTION TearDown
********************************************************************
*
*  put common cleanup code here -- this method is called
*  whenever THIS.Run() (inherited method) to run each
*  of the custom test methods you add, specific test
*  methods that are not inherited from FoxUnit
*
*  do NOT call THIS.Assert..() methods here -- this is
*  NOT a test method
*
    *  for example, you can release  all the object(s)
    *  you will be testing by the custom test methods of 
    *  this class:
*!*	    THIS.ioObjectToBeTested = .NULL.
*!*		LOCAL lcSetClassLib
*!*		lcSetClassLib = THIS.icSetClassLib
*!*		SET CLASSLIB TO &lcSetClassLib        

this.oUndoObject = .null.
This.oForm.Release()
This.oForm = .null.


********************************************************************
ENDFUNC
********************************************************************	

*
*  test methods can use any method name not already used by
*  the parent FXUTestCase class
*    MODIFY COMMAND FXUTestCase
*  DO NOT override any test methods except for the abstract 
*  test methods Setup() and TearDown(), as described above
*
*  the three important inherited methods that you call
*  from your test methods are:
*    THIS.AssertTrue("Failure message",<Expression>)
*    THIS.AssertEquals("Failure message",<ExpectedValue>,<Expression>)
*    THIS.AssertNotNull("Failure message",<Expression>)
*  all test methods either pass or fail -- the assertions
*  either succeed or fail
    
*
*  here's a simple AssertNotNull example test method
*
	*********************************************************************
	FUNCTION TestObjectWasCreated
	*********************************************************************
	THIS.AssertNotNull("Object was not instantiated during Setup()", ;
		               THIS.oForm.oUndoObject)
		               
	This.AssertEquals("Parent not hooked", This.oForm, This.oForm.oUndoObject.oParent)		               
	*********************************************************************
	ENDFUNC
	*********************************************************************

*
*  here's one for AssertTrue
*
*!*		*********************************************************************
*!*		FUNCTION TestObjectCustomMethod 
*!*		*********************************************************************
*!*		THIS.AssertTrue("Object.CustomMethod() failed", ;
*!*			            THIS.ioObjectToBeTested.CustomMethod())
*!*		*********************************************************************
*!*		ENDFUNC
*!*		*********************************************************************

*
*  and one for AssertEquals
*
*!*		*********************************************************************
*!*		FUNCTION TestObjectCustomMethod100ReturnValue 
*!*		*********************************************************************
*!*
*!*		* Please note that string Comparisons with AssertEquals are
*!*		* case sensitive. 
*!*
*!*		THIS.AssertEquals("Object.CustomMethod100() did not return 'John Smith'", ;
*!*		                "John Smith", ;
*!*			            THIS.ioObjectToBeTested.Object.CustomMethod100())
*!*		*********************************************************************
*!*		ENDFUNC
*!*		*********************************************************************


	**********************************************
	FUNCTION TestAddObjectToForm
	**********************************************
	
	This.AssertNotNull("Undo object was not added to form", ;
	                   PEMSTATUS(This.oForm, "oUndoObject", 5) and not ISNULL(This.oForm.oUndoObject))
	                   
	**********************************************
	ENDFUNC 
	**********************************************

	**********************************************
	FUNCTION TestAddItemsToUndoList
	**********************************************

	This.AssertNotNull("Undo Items collection not created", This.oForm.oUndoObject.colUndoItems)
	
	This.oForm.oUndoObject.AddUndoItem("Top", "This.Top")
	This.oForm.oUndoObject.AddUndoItem("Left", "This.Left")
	
	This.AssertEquals("Undo items not added properly", 2, This.oForm.oUndoObject.GetItemCount())
	
	**********************************************
	ENDFUNC 
	**********************************************

	**********************************************
	FUNCTION TestGetUndoCount
	**********************************************
	This.AssertEquals("Collection count is wrong", 0, This.oForm.oUndoObject.GetItemCount())
	**********************************************
	ENDFUNC 
	**********************************************

	**********************************************
	FUNCTION TestConvertExpression
	**********************************************
	This.oForm.oUndoObject.AddUndoItem("Top", "This.Top")
	
	This.AssertEquals("Expression not correctly converted", ;
	                  "This.oParent.Top", ;
	                  This.oForm.oUndoObject.colUndoItems["Top"].Expression)
	**********************************************
	ENDFUNC 
	**********************************************

**********************************************************************
ENDDEFINE
**********************************************************************
