**********************************************************************
DEFINE CLASS TestUndoRegistry as FxuTestCase OF FxuTestCase.prg
**********************************************************************

	#IF .f.
	LOCAL THIS AS TestUndoRegistry OF TestUndoRegistry.PRG
	#ENDIF
	
	oForm = .null.
	********************************************************************
	FUNCTION Setup
	********************************************************************
	This.oForm = CREATEOBJECT("Form")
	ADDPROPERTY(This.oForm, "oUndoEncoder",NEWOBJECT("UndoEncoding", "UndoEncoding.PRG"))
	ADDPROPERTY(This.oForm, "colUndo", NEWOBJECT("UndoRegistry", "UndoObject.PRG", "", This.oForm.oUndoEncoder))

	********************************************************************
	ENDFUNC
	********************************************************************
	
	********************************************************************
	FUNCTION TearDown
	********************************************************************
	This.oForm.colUndo = .null.
	This.oForm.oUndoEncoder = .null.
	This.oForm.Release() 

	********************************************************************
	ENDFUNC
	********************************************************************	

	PROCEDURE TestObjectWasCreated
	
	This.Assertnotnull("Undo Registry not created", This.oForm.colUndo)
	
	RETURN
	********************************************************************
	ENDPROC
	********************************************************************

	**********************************************
	FUNCTION TestRegister
	**********************************************
	
	This.oForm.AddObject("txtTest1","Textbox")
	ADDPROPERTY(This.oForm.txtTest1, "oUndoObject", NEWOBJECT("UndoValue", "UndoObject.PRG", "", This.oForm))
	This.oForm.coLUNDO.Register(This.oForm.txtTest1.oUndoObject)
	
	This.assertequals("Object not registered", 1, This.oForm.colUndo.Count)
	
	RETURN
	
	**********************************************
	ENDFUNC 
	**********************************************

	**********************************************
	FUNCTION TestRegisterWithApp
	**********************************************
	This.oForm.AddObject("txtTest1","TestTextbox")
	This.oForm.coLUNDO.Register(This.oForm.txtTest1.oUndoObject)

	oUndoEngine = NEWOBJECT("UndoEngine", "UndoEngine.PRG")
		
	This.oForm.colUndo.RegisterWithApp(oUndoEngine)
	
	This.Assertequals("Object not registered with app", 1, oUndoEngine.oUndoList.Count)

	RETURN
		
	**********************************************
	ENDFUNC 
	**********************************************

**********************************************************************
ENDDEFINE
**********************************************************************

DEFINE CLASS TestTextbox AS Textbox

oUndoObject = .null.

PROCEDURE Init

This.oUndoObject = NEWOBJECT("UndoValue", "UndoObject.PRG", "", This)

RETURN
ENDPROC

PROCEDURE CleanUp

This.oUndoObject.CleanUp()

RETURN
ENDPROC

PROCEDURE AnyChange
ENDPROC

ENDDEFINE
