**********************************************************************
DEFINE CLASS TestXMLUndoEncoding as FxuTestCase OF FxuTestCase.prg
**********************************************************************
	#IF .f.
	*
	*  this LOCAL declaration enabled IntelliSense for
	*  the THIS object anywhere in this class
	*
	LOCAL THIS AS TestXMLUndoEncoding OF TestXMLUndoEncoding.PRG
	#ENDIF
	
	*  
	*  declare properties here that are used by one or
	*  more individual test methods of this class
	*
	*  for example, if you create an object to a custom
	*  THIS.Property in THIS.Setup(), estabish the property
	*  here, where it will be available (to IntelliSense)
	*  throughout:
	*
*!*		ioObjectToBeTested = .NULL.
*!*		icSetClassLib = SPACE(0)

	oForm = .null.
	oEncoder = .null.
	
	* the icTestPrefix property in the base FxuTestCase class defaults
	* to "TEST" (not case sensitive). There is a setting on the interface
	* tab of the options form (accessible via right-clicking on the
	* main FoxUnit form and choosing the options item) labeld as
	* "Load and run only tests with the specified icTestPrefix value in test classes"
	*
	* If this is checked, then only tests in any test class that start with the
	* prefix specified with the icTestPrefix property value will be loaded
	* into FoxUnit and run. You can override this prefix on a per-class basis.
	*
	* This makes it possible to create ancillary methods in your test classes
	* that can be shared amongst other test methods without being run as
	* tests themselves. Additionally, this means you can quickly and easily 
	* disable a test by modifying it and changing it's test prefix from
	* that specified by the icTestPrefix property
	
	* Additionally, you could set this in the INIT() method of your derived class
	* but make sure you dodefault() first. When the option to run only
	* tests with the icTestPrefix specified is checked in the options form,
	* the test classes are actually all instantiated individually to pull
	* the icTestPrefix value.

*!*		icTestPrefix = "<Your preferred prefix here>"
	
	********************************************************************
	FUNCTION Setup
	********************************************************************
	*
	*  put common setup code here -- this method is called
	*  whenever THIS.Run() (inherited method) to run each
	*  of the custom test methods you add, specific test
	*  methods that are not inherited from FoxUnit
	*
	*  do NOT call THIS.Assert..() methods here -- this is
	*  NOT a test method
	*
    *  for example, you can instantiate all the object(s)
    *  you will be testing by the custom test methods of 
    *  this class:
*!*		THIS.icSetClassLib = SET("CLASSLIB")
*!*		SET CLASSLIB TO MyApplicationClassLib.VCX ADDITIVE
*!*		THIS.ioObjectToBeTested = CREATEOBJECT("MyNewClassImWriting")

	This.oForm = CREATEOBJECT("Form")
	This.oForm.AddProperty("oUndoObject", ;
	                       NEWOBJECT("UndoList", "UndoObject.PRG","", This.oForm))
	                       
	This.oEncoder = NEWOBJECT("XMLUndoEncoding", "UndoEncoding.PRG")

	********************************************************************
	ENDFUNC
	********************************************************************
	
	********************************************************************
	FUNCTION TearDown
	********************************************************************
	*
	*  put common cleanup code here -- this method is called
	*  whenever THIS.Run() (inherited method) to run each
	*  of the custom test methods you add, specific test
	*  methods that are not inherited from FoxUnit
	*
	*  do NOT call THIS.Assert..() methods here -- this is
	*  NOT a test method
	*
    *  for example, you can release  all the object(s)
    *  you will be testing by the custom test methods of 
    *  this class:
*!*	    THIS.ioObjectToBeTested = .NULL.
*!*		LOCAL lcSetClassLib
*!*		lcSetClassLib = THIS.icSetClassLib
*!*		SET CLASSLIB TO &lcSetClassLib        

	This.oForm.Release()
	This.oForm = .null.
	This.oEncoder = .null.

	********************************************************************
	ENDFUNC
	********************************************************************	

	*
	*  test methods can use any method name not already used by
	*  the parent FXUTestCase class
	*    MODIFY COMMAND FXUTestCase
	*  DO NOT override any test methods except for the abstract 
	*  test methods Setup() and TearDown(), as described above
	*
	*  the three important inherited methods that you call
	*  from your test methods are:
	*    THIS.AssertTrue("Failure message",<Expression>)
	*    THIS.AssertEquals("Failure message",<ExpectedValue>,<Expression>)
	*    THIS.AssertNotNull("Failure message",<Expression>)
	*  all test methods either pass or fail -- the assertions
	*  either succeed or fail
    
	*
	*  here's a simple AssertNotNull example test method
	*
*!*		*********************************************************************
*!*		FUNCTION TestObjectWasCreated
*!*		*********************************************************************
*!*		THIS.AssertNotNull("Object was not instantiated during Setup()", ;
*!*			               THIS.ioObjectToBeTested)
*!*		*********************************************************************
*!*		ENDFUNC
*!*		*********************************************************************

	*
	*  here's one for AssertTrue
	*
*!*		*********************************************************************
*!*		FUNCTION TestObjectCustomMethod 
*!*		*********************************************************************
*!*		THIS.AssertTrue("Object.CustomMethod() failed", ;
*!*			            THIS.ioObjectToBeTested.CustomMethod())
*!*		*********************************************************************
*!*		ENDFUNC
*!*		*********************************************************************

	*
	*  and one for AssertEquals
	*
*!*		*********************************************************************
*!*		FUNCTION TestObjectCustomMethod100ReturnValue 
*!*		*********************************************************************
*!*
*!*		* Please note that string Comparisons with AssertEquals are
*!*		* case sensitive. 
*!*
*!*		THIS.AssertEquals("Object.CustomMethod100() did not return 'John Smith'", ;
*!*		                "John Smith", ;
*!*			            THIS.ioObjectToBeTested.Object.CustomMethod100())
*!*		*********************************************************************
*!*		ENDFUNC
*!*		*********************************************************************


	**********************************************
	FUNCTION TestObjectWasCreated
	**********************************************
	This.AssertNotNull("XML Undo Encoder was not created", This.oEncoder)
	
	**********************************************
	ENDFUNC 
	**********************************************

	**********************************************
	FUNCTION TestEncode
	**********************************************
	
	LOCAL cEncoded, cXML
	
	This.oForm.oUndoObject.AddUndoItem("Top", "This.Top")
	This.oForm.oUndoObject.AddUndoItem("Left", "This.Left")
	This.oForm.oUndoObject.AddUndoItem("Visible", "This.Visible")
	
	cEncoded = This.oEncoder.EncodeItems(This.oForm.oUndoObject, This.oForm.oUndoObject.oContext)
	
	This.AssertTrue("Encoded string not created", not EMPTY(m.cEncoded))
	
	TEXT TO m.cXML NOSHOW 
<vfpdata>
<UndoItem name="Top" expression="This.oContext.Top" type="N" value="0" />
<UndoItem name="Left" expression="This.oContext.Left" type="N" value="0" />
<UndoItem name="Visible" expression="This.oContext.Visible" type="L" value=".F." />
</vfpdata>

	ENDTEXT
	
	This.AssertEquals("Encoded string is incorrect", m.cXML, m.cEncoded)

	RETURN

	**********************************************
	ENDFUNC 
	**********************************************

	**********************************************
	FUNCTION TestDecode
	**********************************************
	LOCAL cXML
	
	TEXT TO m.cXML NOSHOW 
<vfpdata>
<UndoItem name="Top" expression="This.oContext.Top" type="N" value="30" />
<UndoItem name="Left" expression="This.oContext.Left" type="N" value="30" />
<UndoItem name="Visible" expression="This.oContext.Visible" type="L" value=".T." />
</vfpdata>

	ENDTEXT
	
	This.oEncoder.DecodeItems(m.cXML, This.oForm)
	
	This.AssertEquals("Top not correct", 30, This.oForm.Top)
	This.AssertEquals("Left not correct", 30, This.oForm.Left)
	This.AssertEquals("Visible not correct", .T., This.oForm.Visible)
	**********************************************
	ENDFUNC 
	**********************************************

	**********************************************
	FUNCTION TestConvertToType
	**********************************************
	LOCAL uResult
	
	uResult = This.oEncoder.ConvertToType("Test data", "C")
	This.AssertEquals("Char not converted", "C", VARTYPE(uResult))

	uResult = This.oENCODER.ConvertToType("30", "N")
	This.AssertEquals("Numeric not converted", "N", VARTYPE(uResult))
	
	uResult = This.oEncoder.ConvertToType(".T.", "L")
	This.AssertEquals("True not converted", "L", VARTYPE(uResult))
	
	uResult = This.oEncoder.ConvertToType(".F.", "L")
	This.AssertEquals("False not converted", "L", VARTYPE(uResult))

	uResult = This.oEncoder.ConvertToType("{07/26/06}", "D")
	This.AssertEquals("Short date not converted", "D", VARTYPE(uResult))

	uResult = This.oEncoder.ConvertToType("{07/26/2006}", "D")
	This.AssertEquals("Long date not converted", "D", VARTYPE(uResult))

	uResult = This.oEncoder.ConvertToType("{07/26/06 1:32}", "T")
	This.AssertEquals("Short datetime not converted", "T", VARTYPE(uResult))
	
	uResult = This.oEncoder.ConvertToType("{07/26/2006 1:32}", "T")
	This.AssertEquals("Short datetime not converted", "T", VARTYPE(uResult))

	**********************************************
	ENDFUNC 
	**********************************************

**********************************************************************
ENDDEFINE
**********************************************************************
