DEFINE CLASS UndoEncoding AS Custom

oContext = .null.

PROCEDURE Destroy

This.CleanUp()

RETURN
ENDPROC

PROCEDURE CleanUp

This.oContext = .null.

RETURN
ENDPROC

PROCEDURE EncodeItems( oUndoItems, oContext )
* Abstract

RETURN 
ENDPROC

PROCEDURE DecodeItems(cUndoData, oContext)
* Abstract

RETURN
ENDPROC

ENDDEFINE


DEFINE CLASS XMLUndoEncoding AS UndoEncoding
* Subclass puts items and values in XML format.

PROCEDURE EncodeItems(oUndoItems, oContext)

LOCAL oUndoItem, cItemXML, cReturn, uVal

cReturn = "<vfpdata>" + CHR(13) + CHR(10)

This.oContext = m.oContext

FOR EACH oUndoItem IN oUndoItems FOXOBJECT
	uVal = EVALUATE(oUndoItem.Expression)
	TEXT TO m.cItemXML NOSHOW TEXTMERGE 
<UndoItem name="<<oUndoItem.Key>>" expression="<<oUndoItem.Expression>>" type="<<TYPE('uVal')>>" value="<<uVal>>" />

	ENDTEXT
	
	cReturn = m.cReturn + m.cItemXML
ENDFOR

cReturn = m.cReturn + "</vfpdata>" + CHR(13) + CHR(10)

This.oContext = .null.

RETURN m.cReturn

PROCEDURE DecodeItems(cUndoString, oContext)

LOCAL cExpr, uValue

This.oContext = m.oContext

XMLTOCURSOR(cUndoString, "__UndoData")

* Process items
SCAN
	cExpr = __UndoData.Expression
	uValue = This.ConvertToType(__UndoData.Value, __UndoData.Type)
	STORE uValue TO (cExpr)
ENDSCAN 

USE IN SELECT("__UndoData")
This.oContext = .null.

RETURN
ENDPROC

FUNCTION ConvertToType(cValue, cType)

LOCAL uReturn

DO CASE
CASE cType="C"
	uReturn = m.cValue
CASE cType = "N"
	uReturn = VAL(m.cValue)
CASE cType = "D"
	uReturn = CTOD(m.cValue)
CASE cType = "T"
	uReturn = CTOT(m.cValue)
CASE cType = "L"
	DO CASE 
	CASE INLIST(m.cValue, "T", ".T.", "t", ".t.")
		uReturn=.T.
	CASE INLIST(m.cValue, "F", ".F.", "f", ".f.")
		uReturn= .F.
	OTHERWISE
		uReturn = .null.
	ENDCASE
OTHERWISE
	uReturn = m.cValue
ENDCASE

RETURN m.uReturn
ENDDEFINE

