DEFINE CLASS UndoList AS Collection

oContext = .null.
cMethod = ""
cCategory = ""

PROCEDURE Init(oContext)

This.oContext = m.oContext
This.AddItems()

ENDPROC

PROCEDURE Destroy

This.CleanUp()

ENDPROC

PROCEDURE CleanUp
* Clean up

This.Remove(-1)
This.oContext = .null.

RELEASE This

RETURN
ENDPROC


PROCEDURE AddUndoItem(cKey, cExpression)

LOCAL oUndoItem, cConvExpression

cConvExpression = STRTRAN(m.cExpression, "This.", "This.oContext.")
oUndoItem = CREATEOBJECT("Empty")
ADDPROPERTY(oUndoItem, "Key", m.cKey)
ADDPROPERTY(oUndoItem, "Expression", m.cConvExpression)

This.Add(m.oUndoItem, m.cKey)

RETURN 
ENDPROC

PROCEDURE GetItemCount

RETURN This.Count
ENDPROC

PROCEDURE AddItems
* Abstract
ENDPROC

ENDDEFINE

DEFINE CLASS UndoValue AS UndoList

cMethod = "AnyChange"
cCategory = "Control Change"

PROCEDURE AddItems

This.AddUndoItem("Value", "This.Value")

RETURN
ENDPROC

ENDDEFINE

DEFINE CLASS UndoRegistry AS Collection

oUndoEncoder = .null.

PROCEDURE Init(oUndoEncoder)

This.oUndoEncoder = m.oUndoEncoder

RETURN
ENDPROC

PROCEDURE Destroy

This.CleanUp()

RETURN
ENDPROC

PROCEDURE CleanUp

This.Remove(-1)
This.oUndoEncoder = .null.

RETURN
ENDPROC

PROCEDURE Register(oUndoObject)

This.Add(oUndoObject)

RETURN
ENDPROC

PROCEDURE RegisterWithApp(oAppUndo)

LOCAL oUndoObject

FOR EACH oUndoObject IN This FOXOBJECT 
	oAppUndo.Register(  oUndoObject.oContext, oUndoObject.cMethod, oUndoObject.cCategory, ;
	                                     "This.oUndoEncoder.EncodeItems", "This.oUndoEncoder.DecodeItems")
ENDFOR 

RETURN
ENDPROC

ENDDEFINE
